
% Testfunktionen
% ==============
% Dimension 1
% testFct1: Minimum von f = 3 bei x = 0 
testFct1 = inline('x^2 + 3', 'x');

% Dimension 2
% testFct2: Minimum von f = 3 bei X = [-3 5]'
testFct2 = inline('(X(1)+3)^2 + (X(2)-5)^2 + 3', 'X');
% testFct3: kein Minimum vorhanden
testFct3 = inline('X(1)^2 - X(2) + 3', 'X');
% testFct4:
testFct4 = inline('3*X(1)^2 - X(2)^3 + (X(2)-3)^4 + 3', 'X');

% Dimension 5
% testFct5: Minimum von f = 10 bei X = [1 16 -2 0 -18]'
testFct5 = inline('(X(1)-1)^2 + (X(2)-16)^2 + (X(3)+2)^4 + 5*norm(X(4)) + (X(5)+18)^2 + 10', 'X');



% Auswahl Testfunktion
% ====================
fitnessFct = testFct5;
% An Dimension anpassen:
% nDim = 1;
% SeekArea = [-10 20];
% nDim = 2;
% SeekArea = [-10 20; -10 20];
nDim = 5;
SeekArea = 1000*[-1 1;-1 1;-1 1;-1 1;-1 1];

% Parameter
% =========
nParents = 20;
nOffspring = 140;
bRecombine = 1;
bParentsDying = 1;

sigmaInit = 100;
sigma_min = 1e-6;
sigma_max = Inf;

tau_0 = 0.1;
tau_1 = 0.15;

eps_min = 1e-6;
eps_min_q = 1e-9;
q = 10;
nMaxGenerations = 1500;

bDisplay = 0;

% Aufruf Funktion
% ===============
[X_min f_min bFoundMin] = evolution(fitnessFct, nDim, SeekArea, nParents, nOffspring, bRecombine, bParentsDying, sigmaInit, sigma_min, sigma_max, tau_0, tau_1, eps_min, eps_min_q, q, nMaxGenerations, bDisplay)